from OpenGL.GL import *;
from OpenGL.GLU import *;
import math;
import pygame;
import mytexture;
import sys;


class myFont:
	def __init__(self, texname ):
		self.texture = mytexture.loadTexture(texname);
		self.FTW = .125;
		self.FTH = .156;
		#/defining the texture coords
		#/All capital letters
		self.FontTexCoords ={};

		self.FontTexCoords['A'] = [0,0];
		self.FontTexCoords['A'][0] = 0;	
		self.FontTexCoords['A'][1] = 0;	

		self.FontTexCoords['B']= [0,0];
		self.FontTexCoords['B'][0] = self.FTW;
		self.FontTexCoords['B'][1] = 0;	

		self.FontTexCoords['C']= [0,0];
		self.FontTexCoords['C'][0] = 2*self.FTW;
		self.FontTexCoords['C'][1] = 0;	
		self.FontTexCoords['D']= [0,0];
		self.FontTexCoords['D'][0] = 3*self.FTW;
		self.FontTexCoords['D'][1] = 0;	
		self.FontTexCoords['E']= [0,0];
		self.FontTexCoords['E'][0] = 4*self.FTW;
		self.FontTexCoords['E'][1] = 0;	
		self.FontTexCoords['F']= [0,0];
		self.FontTexCoords['F'][0] = 5*self.FTW;
		self.FontTexCoords['F'][1] = 0;	
		self.FontTexCoords['G']= [0,0];
		self.FontTexCoords['G'][0] = 6*self.FTW;
		self.FontTexCoords['G'][1] = 0;	
		self.FontTexCoords['H']= [0,0];
		self.FontTexCoords['H'][0] = 0*self.FTW;
		self.FontTexCoords['H'][1] = 1*self.FTH;
		self.FontTexCoords['I']= [0,0];
		self.FontTexCoords['I'][0] = 1*self.FTW;
		self.FontTexCoords['I'][1] = 1*self.FTH;
		self.FontTexCoords['J']= [0,0];
		self.FontTexCoords['J'][0] = 2*self.FTW;
		self.FontTexCoords['J'][1] = 1*self.FTH;
		self.FontTexCoords['K']= [0,0];
		self.FontTexCoords['K'][0] = 3*self.FTW;
		self.FontTexCoords['K'][1] = 1*self.FTH;
		self.FontTexCoords['L']= [0,0];
		self.FontTexCoords['L'][0] = 4*self.FTW;
		self.FontTexCoords['L'][1] = 1*self.FTH;
		self.FontTexCoords['M']= [0,0];
		self.FontTexCoords['M'][0] = 5*self.FTW;
		self.FontTexCoords['M'][1] = 1*self.FTH;
		self.FontTexCoords['N']= [0,0];
		self.FontTexCoords['N'][0] = 6*self.FTW;
		self.FontTexCoords['N'][1] = 1*self.FTH;
		self.FontTexCoords['O']= [0,0];
		self.FontTexCoords['O'][0] = 0*self.FTW;
		self.FontTexCoords['O'][1] = 2*self.FTH;
		self.FontTexCoords['P']= [0,0];
		self.FontTexCoords['P'][0] = 1*self.FTW;
		self.FontTexCoords['P'][1] = 2*self.FTH;
		self.FontTexCoords['Q']= [0,0];
		self.FontTexCoords['Q'][0] = 2*self.FTW;
		self.FontTexCoords['Q'][1] = 2*self.FTH;
		self.FontTexCoords['R']= [0,0];
		self.FontTexCoords['R'][0] = 3*self.FTW;
		self.FontTexCoords['R'][1] = 2*self.FTH;
		self.FontTexCoords['S']= [0,0];
		self.FontTexCoords['S'][0] = 4*self.FTW;
		self.FontTexCoords['S'][1] = 2*self.FTH;
		self.FontTexCoords['T']= [0,0];
		self.FontTexCoords['T'][0] = 5*self.FTW;
		self.FontTexCoords['T'][1] = 2*self.FTH;
		self.FontTexCoords['U']= [0,0];
		self.FontTexCoords['U'][0] = 6*self.FTW;
		self.FontTexCoords['U'][1] = 2*self.FTH;
		self.FontTexCoords['V']= [0,0];
		self.FontTexCoords['V'][0] = 0*self.FTW;
		self.FontTexCoords['V'][1] = 3*self.FTH;
		self.FontTexCoords['W']= [0,0];
		self.FontTexCoords['W'][0] = 1*self.FTW;
		self.FontTexCoords['W'][1] = 3*self.FTH;
		self.FontTexCoords['X']= [0,0];
		self.FontTexCoords['X'][0] = 2*self.FTW;
		self.FontTexCoords['X'][1] = 3*self.FTH;
		self.FontTexCoords['Y']= [0,0];
		self.FontTexCoords['Y'][0] = 3*self.FTW;
		self.FontTexCoords['Y'][1] = 3*self.FTH;
		self.FontTexCoords['Z']= [0,0];
		self.FontTexCoords['Z'][0] = 4*self.FTW;
		self.FontTexCoords['Z'][1] = 3*self.FTH;

		#/numbers
		self.FontTexCoords['1']= [0,0];
		self.FontTexCoords['1'][0] = 5*self.FTW;
		self.FontTexCoords['1'][1] = 3*self.FTH;
		self.FontTexCoords['2']= [0,0];
		self.FontTexCoords['2'][0] = 6*self.FTW;
		self.FontTexCoords['2'][1] = 3*self.FTH;
		self.FontTexCoords['3']= [0,0];
		self.FontTexCoords['3'][0] = 0*self.FTW;
		self.FontTexCoords['3'][1] = 4*self.FTH;
		self.FontTexCoords['4']= [0,0];
		self.FontTexCoords['4'][0] = 1*self.FTW;
		self.FontTexCoords['4'][1] = 4*self.FTH;
		self.FontTexCoords['5']= [0,0];
		self.FontTexCoords['5'][0] = 2*self.FTW;
		self.FontTexCoords['5'][1] = 4*self.FTH;
		self.FontTexCoords['6']= [0,0];
		self.FontTexCoords['6'][0] = 3*self.FTW;
		self.FontTexCoords['6'][1] = 4*self.FTH;
		self.FontTexCoords['7']= [0,0];
		self.FontTexCoords['7'][0] = 4*self.FTW;
		self.FontTexCoords['7'][1] = 4*self.FTH;
		self.FontTexCoords['8']= [0,0];
		self.FontTexCoords['8'][0] = 5*self.FTW;
		self.FontTexCoords['8'][1] = 4*self.FTH;
		self.FontTexCoords['9']= [0,0];
		self.FontTexCoords['9'][0] = 6*self.FTW;
		self.FontTexCoords['9'][1] = 4*self.FTH;
		self.FontTexCoords['0']= [0,0];
		self.FontTexCoords['0'][0] = 0*self.FTW;
		self.FontTexCoords['0'][1] = 5*self.FTH;
		
		#/special chars
		self.FontTexCoords[' ']= [0,0];
		self.FontTexCoords[' '][0] = 1*self.FTW;
		self.FontTexCoords[' '][1] = 5*self.FTH;
		self.FontTexCoords['-']= [0,0];
		self.FontTexCoords['-'][0] = 2*self.FTW;
		self.FontTexCoords['-'][1] = 5*self.FTH;
		self.FontTexCoords['!']= [0,0];
		self.FontTexCoords['!'][0] = 3*self.FTW;
		self.FontTexCoords['!'][1] = 5*self.FTH;
		self.FontTexCoords[':']= [0,0];
		self.FontTexCoords[':'][0] = 4*self.FTW;
		self.FontTexCoords[':'][1] = 5*self.FTH;
		self.FontTexCoords['?']= [0,0];
		self.FontTexCoords['?'][0] = 5*self.FTW;
		self.FontTexCoords['?'][1] = 5*self.FTH;
		self.FontTexCoords['&']= [0,0];
		self.FontTexCoords['&'][0] = 6*self.FTW;
		self.FontTexCoords['&'][1] = 6*self.FTH;


	def drawString( self, str, x, y, fwidth=20, fheight=20 ):
		add_x = 10.0/128.0;
		add_y = 15.0/128.0;
		loopvar = 0;
		limit = len(str);	
		if limit == 0:
			return;
		glEnable( GL_TEXTURE_2D )	
		glBindTexture( GL_TEXTURE_2D, self.texture );		
		for i in xrange(limit):
			glBegin( GL_POLYGON );
			glTexCoord2f( self.FontTexCoords[str[i]][0], 1-self.FontTexCoords[str[i]][1] );
			glVertex2f( i*fwidth+x, y );
			glTexCoord2f( self.FontTexCoords[str[i]][0]+self.FTW, 1-self.FontTexCoords[str[i]][1] );
			glVertex2f( x+(i+1)*fwidth, y );		
			glTexCoord2f( self.FontTexCoords[str[i]][0]+self.FTW, 1-self.FontTexCoords[str[i]][1]-self.FTH );
			glVertex2f( x+(i+1)*fwidth, y-fheight );		
			glTexCoord2f( self.FontTexCoords[str[i]][0], 1-self.FontTexCoords[str[i]][1]-self.FTH );
			glVertex2f( i*fwidth+x, y-fheight );		
			glEnd( );
		glDisable( GL_TEXTURE_2D )	
