from OpenGL.GL import *
from OpenGL.GLU import *
import sys
import pygame
from pygame import locals


def loadTexture( imageName = None ):
	if imageName == None :
		sys.exit(1)
	ix = iy = 0
	image = ""
	print imageName, "is image Nmae."
	try:
		im = pygame.image.load( imageName )
	except:
		print "Could not open ", imageName;
	try:
		# get image meta-data (dimensions) and data
		ix,iy, image = im.get_width(), im.get_height(), pygame.image.tostring(im,"RGBA",1); 
	except SystemError:
		# has no alpha channel, synthesize one, see the
		# texture module for more realistic handling
		ix,iy, image = im.get_width(), im.get_height(), pygame.image.tostring(im,"RGBX",1); 

	# generate a texture ID
	ID= glGenTextures(1)
	# make it current
	glBindTexture(GL_TEXTURE_2D, ID)
	glPixelStorei(GL_UNPACK_ALIGNMENT,1)
	# copy the texture into the current texture ID

	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST)
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST)
	glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);

	glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA, ix, iy, 0, GL_RGBA, GL_UNSIGNED_BYTE, image)
	
	# return the ID for use
	print "Texture Id", ID
	return ID
